"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRNE2EEManager = useRNE2EEManager;
var _RNE2EEManager = _interopRequireDefault(require("../e2ee/RNE2EEManager"));
var _ = require("..");
var _react = require("react");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/**
 * @experimental
 */
function useRNE2EEManager(options) {
  let [keyProvider] = (0, _react.useState)(() => new _.RNKeyProvider(options.keyProviderOptions ?? {}));
  let [e2eeManager] = (0, _react.useState)(() => new _RNE2EEManager.default(keyProvider));
  (0, _react.useEffect)(() => {
    let setup = async () => {
      try {
        await keyProvider.setSharedKey(options.sharedKey);
      } catch (error) {
        _.log.warn('unable to set shared key', error);
      }
    };
    setup();
    return () => {};
  }, [keyProvider, options.sharedKey]);
  (0, _react.useEffect)(() => {
    return () => {
      keyProvider.dispose();
    };
  }, [keyProvider]);
  return {
    keyProvider,
    e2eeManager
  };
}
//# sourceMappingURL=useE2EEManager.js.map