"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.log = void 0;
exports.setLogLevel = setLogLevel;
var _livekitClient = require("livekit-client");
var _loglevel = _interopRequireDefault(require("loglevel"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const log = exports.log = _loglevel.default.getLogger('lk-react-native');
log.setDefaultLevel('WARN');
/**
 * Set the log level for both the `@livekit/react-native` package and the `@livekit-client` package.
 * To set the `@livekit-client` log independently, use the `liveKitClientLogLevel` prop on the `options` object.
 * @public
 */
function setLogLevel(level, options = {}) {
  log.setLevel(level);
  (0, _livekitClient.setLogLevel)(options.liveKitClientLogLevel ?? level);
}
//# sourceMappingURL=logger.js.map