import { setLogLevel as setClientSdkLogLevel } from 'livekit-client';
import loglevel from 'loglevel';
export const log = loglevel.getLogger('lk-react-native');
log.setDefaultLevel('WARN');
/**
 * Set the log level for both the `@livekit/react-native` package and the `@livekit-client` package.
 * To set the `@livekit-client` log independently, use the `liveKitClientLogLevel` prop on the `options` object.
 * @public
 */
export function setLogLevel(level, options = {}) {
  log.setLevel(level);
  setClientSdkLogLevel(options.liveKitClientLogLevel ?? level);
}
//# sourceMappingURL=logger.js.map