export const __esModule: boolean;
/**
 * @beta
 */
/**
 * Visualizes audio signals from a TrackReference as bars.
 * If the `state` prop is set, it automatically transitions between VoiceAssistant states.
 * @beta
 *
 * @remarks For VoiceAssistant state transitions this component requires a voice assistant agent running with livekit-agents \>= 0.9.0
 *
 * @example
 * ```tsx
 * function SimpleVoiceAssistant() {
 *   const { state, audioTrack } = useVoiceAssistant();
 *   return (
 *    <BarVisualizer
 *      state={state}
 *      trackRef={audioTrack}
 *    />
 *   );
 * }
 * ```
 */
export function BarVisualizer({ style, state, barCount, trackRef, options }: {
    style?: {} | undefined;
    state: any;
    barCount?: number | undefined;
    trackRef: any;
    options: any;
}): any;
export function useBarAnimator(state: any, columns: any, interval: any): any;
