/**
 * Registers the required globals needed for LiveKit to work.
 *
 * Must be called before using LiveKit.
 */
export function registerGlobals(): void;
export * from "./hooks";
export * from "./components/BarVisualizer";
export * from "./components/LiveKitRoom";
export * from "./components/VideoTrack";
export * from "./components/VideoView";
export * from "./useParticipant";
export * from "./useRoom";
export * from "./logger";
export * from "./audio/AudioManager";
import AudioSession from './audio/AudioSession';
import RNE2EEManager from './e2ee/RNE2EEManager';
import RNKeyProvider from './e2ee/RNKeyProvider';
import { AndroidAudioTypePresets } from './audio/AudioSession';
import { getDefaultAppleAudioConfigurationForMode } from './audio/AudioSession';
export { AudioSession, RNE2EEManager, RNKeyProvider, AndroidAudioTypePresets, getDefaultAppleAudioConfigurationForMode };
