import { Room } from 'livekit-client';
import { type AppleAudioConfiguration, type AudioTrackState } from './AudioSession';
/**
 * Handles setting the appropriate AVAudioSession options automatically
 * depending on the audio track states of the Room.
 *
 * @param room
 * @param preferSpeakerOutput
 * @param onConfigureNativeAudio A custom method for determining options used.
 */
export declare function useIOSAudioManagement(room: Room, preferSpeakerOutput?: boolean, onConfigureNativeAudio?: (trackState: AudioTrackState, preferSpeakerOutput: boolean) => AppleAudioConfiguration): void;
